import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogFlawedIntegrityPipeline'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogFlawedIntegrityPipeline, [], {})
        obj_coll_names = ['r1']
        r1__just = [c.range for c in obj.out_edges if c.action == 'write']
        if empty(r1__just):
            continue
        r1__items = next_classes_with_justifications(nodes_in,r1__just)
        for r1 in r1__items.keys():
            r1__evidence = r1__items[r1]
            r1Player = Player(r1, 'r1', -1,RecogFlawedIntegrityPipeline,r1__evidence, {})
            r1_coll_names = ['middle']
            middle__just = [c.range for c in r1.out_edges if c.range != obj and c.action == 'read' and c.domain not in obj.receiving_from]
            if empty(middle__just):
                continue
            middle__items = next_classes_with_justifications(nodes_in,middle__just)
            for middle in middle__items.keys():
                middle__evidence = middle__items[middle]
                middlePlayer = Player(middle, 'middle', -1,RecogFlawedIntegrityPipeline,middle__evidence, {})
                middle_coll_names = ['r2']
                r2__just = [c.range for c in middle.out_edges if len(c.range.in_edges) > 1 or len(r1.in_edges) > 1 and c.action == 'write']
                if empty(r2__just):
                    continue
                r2__items = next_classes_with_justifications(nodes_in,r2__just)
                for r2 in r2__items.keys():
                    r2__evidence = r2__items[r2]
                    r2Player = Player(r2, 'r2', -1,RecogFlawedIntegrityPipeline,r2__evidence, {})
                    r2_coll_names = ['end']
                    end__just = [c.range for c in r2.out_edges if c.range not in obj.receiving_from and c.range != obj and c.action == 'read' and c.range != middle and c.range not in middle.receiving_from]
                    if empty(end__just):
                        continue
                    end__items = next_classes_with_justifications(nodes_in,end__just)
                    end = end__items.keys()
                    end__aggr = make_aggr('end',RecogFlawedIntegrityPipeline,end__items)
                    dict_put(r2Player.with,'end',end__aggr)
                    if empty(setdiff(r2_coll_names,r2Player.with.keys())):
                        dict_put(middlePlayer.with,'r2',r2Player)
                if empty(setdiff(middle_coll_names,middlePlayer.with.keys())):
                    dict_put(r1Player.with,'middle',middlePlayer)
            if empty(setdiff(r1_coll_names,r1Player.with.keys())):
                dict_put(objPlayer.with,'r1',r1Player)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogFlawedIntegrityPipeline'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogFlawedIntegrityPipeline']
