import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogMediator'] = []
    nbr = 0
    colleagues = []
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogMediator, [], {})
        obj_coll_names = ['r2']
        r2__just = [c.range for c in obj.out_edges]
        if empty(r2__just):
            continue
        r2__items = next_classes_with_justifications(nodes_in,r2__just)
        for r2 in r2__items.keys():
            r2__evidence = r2__items[r2]
            r2Player = Player(r2, 'r2', -1,RecogMediator,r2__evidence, {})
            r2_coll_names = ['r3']
            r3__just = [c.domain for c in obj.in_edges]
            if empty(r3__just):
                continue
            r3__items = next_classes_with_justifications(nodes_in,r3__just)
            for r3 in r3__items.keys():
                r3__evidence = r3__items[r3]
                r3Player = Player(r3, 'r3', -1,RecogMediator,r3__evidence, {})
                r3_coll_names = ['colleagues']
                colleagues__just = [x for x in [c.range for c in r2.out_edges] if x in [c.domain for c in r3.in_edges]]
                if empty(colleagues__just):
                    continue
                colleagues__items = next_classes_with_justifications(nodes_in,colleagues__just)
                colleagues = colleagues__items.keys()
                colleagues__aggr = make_aggr('colleagues',RecogMediator,colleagues__items)
                dict_put(r3Player.with,'colleagues',colleagues__aggr)
                if empty(setdiff(r3_coll_names,r3Player.with.keys())):
                    dict_put(r2Player.with,'r3',r3Player)
            if empty(setdiff(r2_coll_names,r2Player.with.keys())):
                dict_put(objPlayer.with,'r2',r2Player)
        if Exists([pair for pair in cross_product(colleagues) if pair[1] in pair[0].sending_to]):
            continue
        if len(colleagues) < 2:
            continue
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogMediator'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogMediator']
