import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogProxy'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogProxy, [], {})
        obj_coll_names = ['r2']
        r2__just = [c.range for c in obj.out_edges if c.action != "activate"]
        if empty(r2__just):
            continue
        r2__items = next_classes_with_justifications(nodes_in,r2__just)
        for r2 in r2__items.keys():
            r2__evidence = r2__items[r2]
            r2Player = Player(r2, 'r2', -1,RecogProxy,r2__evidence, {})
            r2_coll_names = ['service']
            service__just = [c.range for c in r2.out_edges if c.range != obj]
            if empty(service__just):
                continue
            service__items = next_classes_with_justifications(nodes_in,service__just)
            for service in service__items.keys():
                service__evidence = service__items[service]
                servicePlayer = Player(service, 'service', -1,RecogProxy,service__evidence, {})
                service_coll_names = ['r3']
                r3__just = [c.domain for c in obj.in_edges if c.domain in [x.range for x in service.out_edges]]
                if empty(r3__just):
                    continue
                r3__items = next_classes_with_justifications(nodes_in,r3__just)
                for r3 in r3__items.keys():
                    r3__evidence = r3__items[r3]
                    r3Player = Player(r3, 'r3', -1,RecogProxy,r3__evidence, {})
                    r3_coll_names = ['client']
                    client__just = [x for x in obj.receiving_from if x not in service.receiving_from and x != obj and x != service]
                    if empty(client__just):
                        continue
                    client__items = next_classes_with_justifications(nodes_in,client__just)
                    client = client__items.keys()
                    client__aggr = make_aggr('client',RecogProxy,client__items)
                    dict_put(r3Player.with,'client',client__aggr)
                    if empty(setdiff(r3_coll_names,r3Player.with.keys())):
                        dict_put(servicePlayer.with,'r3',r3Player)
                if empty(setdiff(service_coll_names,servicePlayer.with.keys())):
                    dict_put(r2Player.with,'service',servicePlayer)
            if empty(setdiff(r2_coll_names,r2Player.with.keys())):
                dict_put(objPlayer.with,'r2',r2Player)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogProxy'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogProxy']
