import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogWebServer'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogWebServer, [], {})
        obj_coll_names = ['r1']
        r1__just = [c.domain for c in obj.in_edges]
        if empty(r1__just):
            continue
        r1__items = next_classes_with_justifications(nodes_in,r1__just)
        for r1 in r1__items.keys():
            r1__evidence = r1__items[r1]
            r1Player = Player(r1, 'r1', -1,RecogWebServer,r1__evidence, {})
            r1_coll_names = ['shell']
            shell__just = [c.domain for c in r1.in_edges]
            if empty(shell__just):
                continue
            shell__items = next_classes_with_justifications(nodes_in,shell__just)
            for shell in shell__items.keys():
                shell__evidence = shell__items[shell]
                shellPlayer = Player(shell, 'shell', -1,RecogWebServer,shell__evidence, {})
                shell_coll_names = ['r2']
                r2__just = [c.range for c in shell.out_edges]
                if empty(r2__just):
                    continue
                r2__items = next_classes_with_justifications(nodes_in,r2__just)
                for r2 in r2__items.keys():
                    r2__evidence = r2__items[r2]
                    r2Player = Player(r2, 'r2', -1,RecogWebServer,r2__evidence, {})
                    r2_coll_names = ['r3']
                    r3__just = [c.domain for c in shell.in_edges]
                    if empty(r3__just):
                        continue
                    r3__items = next_classes_with_justifications(nodes_in,r3__just)
                    for r3 in r3__items.keys():
                        r3__evidence = r3__items[r3]
                        r3Player = Player(r3, 'r3', -1,RecogWebServer,r3__evidence, {})
                        r3_coll_names = ['script']
                        script__just = [c for c in shell.executing if c in obj.executing and c in intersect([x.domain for x in r3.in_edges], [x.range for x in r2.out_edges])]
                        if empty(script__just):
                            continue
                        script__items = next_classes_with_justifications(nodes_in,script__just)
                        script = script__items.keys()
                        script__aggr = make_aggr('script',RecogWebServer,script__items)
                        dict_put(r3Player.with,'script',script__aggr)
                        if empty(setdiff(r3_coll_names,r3Player.with.keys())):
                            dict_put(r2Player.with,'r3',r3Player)
                    if empty(setdiff(r2_coll_names,r2Player.with.keys())):
                        dict_put(shellPlayer.with,'r2',r2Player)
                if empty(setdiff(shell_coll_names,shellPlayer.with.keys())):
                    dict_put(r1Player.with,'shell',shellPlayer)
            if empty(setdiff(r1_coll_names,r1Player.with.keys())):
                dict_put(objPlayer.with,'r1',r1Player)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogWebServer'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogWebServer']
