
from util import *
import string


############ dictionaries and lists ########
alternatives = {}

    
""" The listing of the pattern types we recognize """   
PATTERN_TYPES = []

############ classes ###################

class UnderstandingObj:
    desc = ""
    
class SpecObj(UnderstandingObj):
    """ SpecObjs detect patterns by applying sequenced or cascading Recogs
    to the classObjects in the search_set"""
    pattern = None
    do_rp = 1
    recall = 0
    precision = 0
    prerequisites = []
    prototypicality = "exact"
    stoppers = []
    description = ""
    collections = []
    focus_name = ""
    inputs = []
    search_set = "get_prgm_classes()"
    prerequisites = []
    
class Recog(UnderstandingObj):
    """ Recogs are used in creating specifications for the players of patterns"""
    def __init__(self, collector, collaborators = [], stoppers = []):
        self.collector = collector
        self.with = collaborators
        self.stoppers = stoppers
        
    def __repr__(self):
        return "<" + self.collector + ">"

def get_label (recogObj):
    return string.split(recogObj.collector)[0]

def get_accessor (recogObj):
    return string.split(recogObj.collector)[4]

def get_code (recogObj):
    return string.join(string.split(recogObj.collector)[5:])

def get_type (recogObj):
    return string.split(recogObj.collector)[2]






