import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogInterpreter'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogInterpreter, [], {})
        obj_coll_names = ['code_file']
        code_file__just = [t.domain for t in obj.in_edges if t.action == "exec" and t.domain.name.find(".py") != -1]
        if empty(code_file__just):
            continue
        code_file__items = next_classes_with_justifications(nodes_in,code_file__just)
        for code_file in code_file__items.keys():
            code_file__evidence = code_file__items[code_file]
            code_filePlayer = Player(code_file, 'code_file', -1,RecogInterpreter,code_file__evidence, {})
            code_file_coll_names = ['interpreter']
            interpreter__just = [t.domain for t in obj.in_edges if t.domain != code_file and t.action == "exec"]
            if empty(interpreter__just):
                continue
            interpreter__items = next_classes_with_justifications(nodes_in,interpreter__just)
            interpreter = interpreter__items.keys()
            interpreter__aggr = make_aggr('interpreter',RecogInterpreter,interpreter__items)
            dict_put(code_filePlayer.with,'interpreter',interpreter__aggr)
            if empty(setdiff(code_file_coll_names,code_filePlayer.with.keys())):
                dict_put(objPlayer.with,'code_file',code_filePlayer)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogInterpreter'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogInterpreter']
