import config
from util import *
import sys
from specs import * 
from gen import Player 
from futil import *


def finder():
    print ''
    prgm = get_current_program()
    prgm.pattern_instances['RecogLibSelinuxInit'] = []
    nbr = 0
    for obj in get_prgm_classes():
        sys.stdout.write('.')
        objPlayer = Player(obj, 'obj', 0,RecogLibSelinuxInit, [], {})
        obj_coll_names = ['mounts']
        mounts__just = [t for t in obj.in_edges if obj_name_contains_one_of(t.domain, ["proc/mounts", "etc/selinux/config"])]
        if empty(mounts__just):
            continue
        mounts__items = next_classes_with_justifications(nodes_in,mounts__just)
        for mounts in mounts__items.keys():
            mounts__evidence = mounts__items[mounts]
            mountsPlayer = Player(mounts, 'mounts', -1,RecogLibSelinuxInit,mounts__evidence, {})
            mounts_coll_names = ['new_access']
            new_access__just = [t.not_obj(obj) for t in (obj.in_edges + obj.out_edges) if t != mounts and obj_name_contains_one_of(t.not_obj(obj), ["etc/selinux/", "proc/mounts"])]
            if empty(new_access__just):
                continue
            new_access__items = next_classes_with_justifications(nodes_in,new_access__just)
            new_access = new_access__items.keys()
            new_access__aggr = make_aggr('new_access',RecogLibSelinuxInit,new_access__items)
            dict_put(mountsPlayer.with,'new_access',new_access__aggr)
            if empty(setdiff(mounts_coll_names,mountsPlayer.with.keys())):
                dict_put(objPlayer.with,'mounts',mountsPlayer)
        #if collaborators, then add to found set
        if empty(setdiff(obj_coll_names, objPlayer.with.keys())):
            nbr = nbr + 1
            objPlayer.nbr = nbr
            prgm.pattern_instances['RecogLibSelinuxInit'].append(objPlayer)
    print nbr
    return prgm.pattern_instances['RecogLibSelinuxInit']
