""" generate list of individual constellation from instance tree"""

def next_nodes_of (node, role):
    ans = []
    next_objects = node.with[role]
    for no in next_objects:
        if no.__class__.__name__ == 'Player':
                ans.append(no)
        else: # must be an aggrecation
            ans = ans + no.elements
    return ans

def get_role (node):
    start = node.pattern_role
    if start == 'obj':
        start = node.recognizer.focus_name
    return start

def instance2individuals (node):
    global ans
    ans = []
    tree2paths(node, [])
    return ans

global ans
ans = []

def tree2paths(node, above):
    """A list of individuals - where an individual is a set of role-resource pairs"""
    #print "In t2paths with node = " +  str(node.focus.name)
    global ans
    role = get_role(node)
    resource = node.focus
    add = resource
    new = []
    for item in above:
        new.append(item)
    new.append(add)
    next_items = []
    for nr in node.with.keys():
        next_nodes = next_nodes_of(node, nr)
        next_items = next_items + next_nodes
    if len(next_items) == 0:
        ans.append(new)
    else:
        for nn in next_items:
            temp = new
            tree2paths(nn, temp)
          
 
